#!/usr/bin/perl 

# --------------------------------------------------------------------------#
#                                                                           #
# Perl Parse Mail Script											      	#   
# Written by Shawn Van Every <vanevery@walking-productions.com>             #
#                                                                           #
# Copyright (c) 2005, 2006, 2007 											#
# Shawn Van Every <vanevery@walking-productions.com>     					#
#                                                                           #
# This program is free software; you can redistribute it and/or             #
# modify it under the terms of the GNU General Public License               #
# as published by the Free Software Foundation; either version 2            #
# of the License, or (at your option) any later version.                    #
#                                                                           #
# See file LICENSE for further informations on licensing terms.             #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program; if not, write to the Free Software Foundation,   #
# Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           #
#                                                                           #
# --------------------------------------------------------------------------#
#
# Version 1.2 Beta
# 
# To Do:
# Make Category Posting Work - Fixed, I think
# Get Spring Messages Working (need a tester)
#
# Recent Changes:
# Adds support for T-Mobile's stupid WMV transcoding
#

###
# Perl modules that need to be installed
###
use MIME::Parser;
use MIME::Entity;
use MIME::Base64;
use Net::POP3;
use XMLRPC::Lite;

###
# User Configurable Variables
###
my $username = "xxxxx"; ## CHANGE THIS LINE
my $password = "xxxx";  ## CHANGE THIS LINE
my $mailserver = "mail.xxxxx.com"; ## CHANGE THIS LINE
my $temp_folder = "/home/xx/xx/temp/"; ## CHANGE THIS LINE
my $attachment_output_folder = "/home/xx/xxxx/posts/"; ## CHANGE THIS LINE
my $attachment_output_folder_relative = "http://xxxx.xxxx.com/posts/"; ## CHANGE THIS LINE
my $blog_xmlrpc_url = "http://xxxx.xxxx.com/xmlrpc.php"; ## CHANGE THIS LINE
my $blog_id = 0; ## CHANGE THIS LINE
my $blog_username = "xxxxx"; ## CHANGE THIS LINE
my $blog_password = "xxxx"; ## CHANGE THIS LINE
## THIS DOESN'T WORK YET
my $post_category = "User Posting"; ## CHANGE THIS LINE 
## NEW
my $image_width = 320;
my $use_wp_plugin = 1;
my $use_wp_alt_plugin = 1;
my $poster_movie = "http://xxxxx.com/xx/xxx.mov";
my $use_poster_movie = 1;

###
# Other Variables that *may be* changed
###
my $pop = Net::POP3->new($mailserver, Timeout => 15);
my $max_chars = 70;  # Number of chars to allow in a line of text from an incoming message
my $delete_messages = 1; # Delete messages from your inbox as they are processed
my $delete_temp_files = 0; # Delete temporary files that are created
my $print_output = 1; # Print output
my $post_to_blog = 1; # Post to your blog?
my $use_gif = 0; # 1 to allow GIF's as attachments, 0 to not allow them (T-Mobile issues)
my @bad_attachments = ("masthead.jpg","dottedLine_600.gif","spacer.gif","video.gif","dottedLine_350.gif"); # A list of attachment filename regular expressions that you don't want included 
my @allowed_domains = ("itp-721bway-167.roam.net.nyu.edu","mobile.att.net","cingularme.com","messaging.sprintpcs.com","tmomail.net","vtext.com","mmode.com","alltel.net","walking-productions.com","vzwpix.com","mms.mycingular.com"); # A list of domains that are allowed to post to this site

my @bad_text = ("nothingatall",
"PIX.*FLIX.*Messaging",
"To.*learn.*how.*you.*can.*snap.*pictures.*with.*your.*wireless.*phone",
"To.*learn.*how.*you.*can",
"www\.verizonwireless\.com",
"To.*play.*video.*messages.*sent.*to.*email",
"process.*when.*asked.*to.*choose.*an.*installation.*type.*Minimum.*Recommended.*or.*Custom.*select",
"If.*you.*can.*read.*this.*text",
"^T-Mobile\$",
"If.*you.*are.*having.*trouble.*playing.*this.*attachment",
"This.*Video.*Message.*was.*sent.*from.*a.*T-Mobile.*video.*phone",
"\.footer.*{",
"font-family:.*Arial,.*;",
"font-size.*;",
"color:.*;",
"text-decoration:.*;",
"normal.*{",
"This.*message.*was.*sent.*using.*service.*from.*Verizon.*Wireless!",
"visit /getitnow/getflix.",
",.*QuickTime.*6.5.*or.*higher.*is.*required..*Visit.*www.apple.com/quicktime/download.*to.*download.*the.*free.*player.*or.*upgrade.*your.*existing.*QuickTime.*Player..*Note:.*During.*the.*download",
"Minimum.*for.*faster.*download.",
"__________________________________________________",
"Do.*You.*Yahoo!?.*",
"Tired.*of.*spam?.*Yahoo!.*Mail.*has.*the.*best.*spam.*protection.*around.*",
"http://mail\.yahoo\.com.*"
); # a list of text regular expressions that you don't want included
# NEED TO WORK ON THIS

my $umask = '0002';  # File creation to 775, 0022 would be 755

my %mime_types = ("image\/jpeg", "jpg",
                    "image\/jpg", "jpg",
                    "image\/gif", "gif",
                    "audio\/x-wav", "wav",
				    "audio/wav", "wav",
                    "video\/mp4", "mp4",
                    "video\/3gpp2", "3g2", # Match this before 3gp as both are matching same file
                    "video\/3gpp", "3gp",
                    "video\/mpeg", "mpg",
                    "video\/quicktime", "mov",
                    "video\/x-quicktime", "mov",
                    "video\/x-msvideo",  "avi",
				    "video\/avi", "avi",
		    		"audio\/x-ms-wmv", "wma",
		    		"video\/x-ms-wmv", "wmv",
		    		"video\/wmv", "wmv",
				    "audio\/wma", "wma"
                ); # A list of the attachment mime types to extract

###
# Parsing Subroutine
###
sub parseMessageParts
{
    my @messageParts = @_;
    
    my $partnum = 0;
    my $is_mime_message = 0;

    while(my $part = shift(@messageParts)) 
    {          
        $is_mime_message = 1;  # Yes we have a mime message
        my $known_type = 0;  # Did we find the type yet?

        # Get the Mime type of the part
        my $type=$part->head->mime_type || $part->head->effective_type; 

		my $already_matched = 0; # 3gp and 3gp2 are both matching on same file..
        
        ## Loop through the types we understand
        foreach $valid_type (keys %mime_types)
        {
		  if ($already_matched != 1) # This is a hack because my matching isn't right
		  {        
            if ($type =~ $valid_type)
            {
                $known_type = 1;
                
                for (my $i = 0; $i <= $#bad_attachments; $i++)
                {          
                    if ($part->head->recommended_filename =~ $bad_attachments[$i])
                    {
                        $skip = 1;
                    }
                }

                if (!$skip)
                {
                    my $attachment = $part->bodyhandle->as_string;
                    my $file_name = "attachment_" . time() . "_" . int(rand(1000)) . "\." . $mime_types{$valid_type};
                    my $image_file = $attachment_output_folder . $file_name;
                    my $fh = new FileHandle "> $image_file";
                    if (defined $fh) {
                            print $fh $attachment;
                            $fh->close;
                    }
                
                    $attachments[++$#attachments] = $file_name;
                    $attachments_type[++$#attachments_type] = $mime_types{$valid_type};
                    $attachments_relative[++$#attachments_relative] = $attachment_output_folder_relative . $file_name;
				    $attachments_mime_type[++$#attachments_mime_type] = $valid_type;
				    $already_matched = 1;
                }    
            }
	  	   } # End $already_matched
        }
        
        ## Not in our list, let's check for text or multipart messages
        if ($known_type == 0)
        {
            if ($type =~ /text\/plain/i)
            {
                my $message_bodyhandle = $part->bodyhandle;
                $mime_message_body = $message_bodyhandle->as_string;

				$mime_message_body =~ s/<.*>//sgi; # Strip out any HTML tags
		
				foreach $badline (@bad_text)
				{
					$mime_message_body =~ s/$badline//sgi;
				}
						
                @mime_message_array = split('\n',$mime_message_body);
                
                foreach $message_line (@mime_message_array)
                {
                    if ($message_line =~ /^\n/ ||
                            $message_line =~ /^\s*\n/ ||
                            $message_line !~ /\w/)
                    {
                       # Ignore blank lines
					   if ($print_output)
					   {
							print "skipping" . $message_line;
					   }
                    }
                    else
                    {
				    	$message_line =~ s/^\s//;
                        $body .= $message_line . "\n";
                    }                                
                }                
            }                       
            elsif ($type =~ /text\/html/i)
            {
                # Plain Text portions or attachments
                my $message_bodyhandle = $part->bodyhandle;
                $mime_message_body = $message_bodyhandle->as_string;
                
				$mime_message_body =~ s/<.*>//sgi; # Strip out any HTML tags

				foreach $badline (@bad_text)
				{
					$mime_message_body =~ s/$badline//sgi;
				}

                @mime_message_array = split('\n',$mime_message_body);

                foreach $message_line (@mime_message_array)
                {
                    if ($message_line =~ /^\n/ ||
                            $message_line =~ /^\s*\n/ ||
                            $message_line !~ /\w/)
                    {
                       # Ignore blank lines
					   if ($print_output)
					   {
							print "skipping " . $message_line . "\n";
					   }
                    }
                    else
                    {
				    	$message_line =~ s/^\s//;
                        $body .= $message_line . "\n"; # Only grabbing first line
                    }                                
                }
            }
            elsif ($type =~ /multipart\/.*/i || $type =~ /message\/.*/i)
            {
                # Multipart Message, Parse This Again
                # Thanks again T-Mobile
                my @otherparts=$part->parts;
                &parseMessageParts(@otherparts);
            }
            else
            {
                if ($print_output)
                {
                    print "Other Type: " . $type . "\n\n"; # OUTPUT
                }
            }
        }
        
        $partnum++;
    }
    return $is_mime_message;
}

###
# Main Program Execution
###
if ($print_output)
{
    print("Running at: " . localtime() . "\n");
}

if ($pop->login($username, $password)) 
{
        $umask = oct($umask) if $umask =~ /^0/;
        umask $umask;
        
        if ($print_output)
        {
            print("Logged into mailserver\n");
        }    
        
        # Create the parser object
        my $parser = MIME::Parser->new();
        $parser->output_dir($temp_folder);
        
        my $msgnums = $pop->list; # hashref of msgnum => size
        foreach my $msgnum (keys %$msgnums) 
        {
                my $msg = $pop->get($msgnum); 
                
                my $entity = $parser->parse_data($msg);
                
                ###
                # GET MESSAGE HEADER
                ###
                my $msg_head = $entity->head;
                my $subject = "";
                my $to = "";
                my $from = "";
                
                ###
                # MESSAGE Related Vars
                ###
                $body = "";
                @attachments = ();
                @attachments_type = ();
                @attachments_relative = ();
				@attachments_mime_type = ();
                
                ##
                # GET MESSAGE SUBJECT
                ##
                if ($msg_head->count('Subject') > 0)
                {
                    $subject = $msg_head->get('Subject');            
                }
                
                ##
                # GET MESSAGE FROM
                ##
                if ($msg_head->count('From') > 0)
                {
                    $from = $msg_head->get('From');
                    if ($from =~ /<(.*)>/)
                    {
                        $from = $1;
                    }
                }

				my $posting_allowed = 0;
				foreach $allowed_domain (@allowed_domains)
				{
					if ($from =~ /.*$allowed_domain.*/)
					{
						$posting_allowed = 1;
						if ($print_output)
						{
							print "Matched: $allowed_domain\n";
						}
					}
				}
                
                ##
                # GET MESSAGE TO
                ##
                if ($msg_head->count('To') > 0)
                {
                    $to = $msg_head->get('To');
                    if ($to =~ /<(.*)>/)
                        {
                            $to = $1;
                        }                   
                }
                
                ###
                # GET MESSAGE PARTS (BODY AND ATTACHMENTS)
                ###
                my @parts=$entity->parts;
                my $is_mime = &parseMessageParts(@parts);  ## Calling our parse subroutine
                                
                ##
                # IF IT ISN'T A MIME MESSAGE (NO ATTACHMENTS)
                ##
                if (!$is_mime)
                {
                    ###
                    # GET MESSAGE BODY LINES
                    ###
                    $msg_body = $entity->body;
                    foreach $message_line (@$msg_body)
                    {
						## Skip bad lines
						$skip = 0;
						foreach $badline (@bad_text)
						{
						if ($message_line =~ /$badline/)
						{
							$skip = 1;
							if ($print_output)
							{
								print "should be skipping\n";
							}
						}
					}
			
					if ($message_line =~ /^\n/ || $skip == 1)
					{
						if ($print_output)
						{
							print "skipping " . $message_line . "\n";
						}
                       	}
                       	else
                       	{
                       		$body .= $message_line;
                       	}
                    }
                }
               
				# IF SUBJECT IS BLANK TAKE FIRST LINE OF BODY
				if ($subject eq "")
				{
					@body_array = split('\n',$body);
					$subject = $body_array[0];
					$body = "";
					for ($b = 1; $b<=$#body_array; $b++)
					{
						$body .= $body_array[$b];
					}
				}
		
                chomp($to); # REMOVE TRAILING LINE BREAKS
                chomp($from);
                chomp($subject);
                chomp($body);
                
                if ($post_to_blog && $posting_allowed)
                {
                    my $attachment_html = "";
                    for (my $i = 0; $i <= $#attachments; $i++)
                    {
                        my $attachment = $attachments[$i];
                        my $attachment_type = $attachments_type[$i];
                        my $attachment_relative = $attachments_relative[$i];
						my $attachment_mime_type = $attachments_mime_type[$i];
                     
                        if ($attachment_type eq "gif" && $use_gif == 1)
						{
							$attachment_html .= "<a href=\"$attachment_relative\" target=\"_NEW\"><img src=\"$attachment_relative\" width=\"$image_width\" border=\"0\" /></a>\n";
						}
						elsif ($attachment_type eq "jpg")
						{
							# Maybe height will be relative? Guess it depends on the browser..
							if ($print_output) { print "Setting Width: $image_width\n"; }

							$attachment_html .= "<a href=\"$attachment_relative\" target=\"_NEW\"><img src=\"$attachment_relative\" width=\"$image_width\" border=\"0\" /></a>\n";
						}
						elsif ( $attachment_type eq "wmv" || $attachment_type eq "wma")
						{
							if ($use_wp_alt_plugin)
							{
								$attachment_html .= "[WINDOWSMEDIA $attachment_relative 320 257]";
							}
							else
							{
								# Normal WMV Tags Here
								
								$attachment_html .= "
								<OBJECT ID=\"MediaPlayer\" WIDTH=\"320\" HEIGHT=\"257\" CLASSID=\"CLSID:22D6F312-B0F6-11D0-94AB-0080C74C7E95\" STANDBY=\"Loading Windows Media Player\" TYPE=\"application/x-oleobject\">
									<PARAM name=\"FileName\" VALUE=\"$attachment_relative\" />
									<PARAM name=\"ShowDisplay\" VALUE=\"false\" />
									<PARAM name=\"ShowControls\" VALUE=\"true\" />
									<PARAM name=\"ShowStatusBar\" VALUE=\"false\" />
									<PARAM name=\"autostart\" VALUE=\"false\" />
									<EMBED TYPE=\"application/x-mplayer2\" NAME=\"MediaPlayer\" SRC=\"$attachment_relative\" ShowControls=\"1\" ShowStatusBar=\"0\" ShowDisplay=\"0\" WIDTH=\"320\" HEIGHT=\"257\" autostart=\"0\"></EMBED>
								</OBJECT>	
								";																
							}
						}
                        elsif (
                                $attachment_type eq "3gp" || $attachment_type eq "wav" || $attachment_type eq "mp4" ||
                                $attachment_type eq "3g2" || $attachment_type eq "mpg" || $attachment_type eq "mov" || 
                                $attachment_type eq "avi"
                                )
                        {
											
						if ($use_wp_plugin)
						{
							if ($use_poster_movie)
							{
								$attachment_html .= "[QUICKTIME $attachment_relative $poster_movie 320 257] <br />Click Image to Play";
							}
							else
							{
			
								$attachment_html .= "[QUICKTIME $attachment_relative 320 257]";
							}
						}
						else
						{
							if ($use_poster_movie)
							{
								$attachment_html .= "
									<OBJECT CLASSID=\"clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B\" WIDTH=\"320\" HEIGHT=\"257\" CODEBASE=\"http://www.apple.com/qtactivex/qtplugin.cab\">
										<PARAM name=\"SRC\" VALUE=\"$poster_movie\">
										<PARAM name=\"HREF\" value=\"$attachment_relative\">
										<PARAM name=\"AUTOPLAY\" VALUE=\"false\">
										<PARAM name=\"CONTROLLER\" VALUE=\"true\">
										<EMBED SRC=\"$poster_movie\" HREF=\"$attachment_relative\" WIDTH=\"320\" HEIGHT=\"257\" AUTOPLAY=\"false\" CONTROLLER=\"true\" PLUGINSPAGE=\"http://www.apple.com/quicktime/download/\"></EMBED>
									</OBJECT>"; 
							}
							else
							{
								$attachment_html .= "
										<OBJECT CLASSID=\"clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B\" WIDTH=\"320\" HEIGHT=\"257\" CODEBASE=\"http://www.apple.com/qtactivex/qtplugin.cab\">
											<PARAM name=\"SRC\" VALUE=\"$attachment_relative\">
											<PARAM name=\"AUTOPLAY\" VALUE=\"false\">
											<PARAM name=\"CONTROLLER\" VALUE=\"true\">
											<EMBED SRC=\"$attachment_relative\" WIDTH=\"320\" HEIGHT=\"257\" AUTOPLAY=\"false\" CONTROLLER=\"true\" PLUGINSPAGE=\"http://www.apple.com/quicktime/download/\"></EMBED>
										</OBJECT>"; 
							}
					   }
					}
				}
                    
		    #if ($print_output) { print $body . "\n" . $attachment_html . "\n"; }
		    
                    my $postresult=XMLRPC::Lite
                               ->proxy($blog_xmlrpc_url)
                               ->call('metaWeblog.newPost',$blog_id,$blog_username,$blog_password,
                                {
                                    'title'=>$subject,
                                    'description'=>$body . "\n" . $attachment_html,
                                    'mt_allow_comments'=>1,
                                    'mt_allow_pings'=>1,
				    				'category'=>$post_category
                                },
                                1
                    )
                    ->result;

                   for (my $i = 0; $i <= $#attachments; $i++)
				   {
						my $attachment = $attachment_output_folder . $attachments[$i];
						my $attachment_type = $attachments_type[$i];
						my $attachment_relative = $attachments_relative[$i];
						my $attachment_mime_type = $attachments_mime_type[$i];

                        my $filesize = -s $attachment;
                        if ($print_output)
                        {
                                print $filesize;
                        }

						my $addencresult = XMLRPC::Lite
								  ->proxy($blog_xmlrpc_url)
								  ->call('demo.addEnclosure',$postresult,$blog_username,$blog_password,
									 $attachment_relative . "\n" 
						 . $filesize . "\n"
									 . $attachment_mime_type)
									->result;
		
							  if ($print_output)
							  {
									print $addencresult;
							  }
				   }
                    
                    if ($print_output)
                    {
                        print "Message To: $to\n";
                        print "Message From $from\n";
                        print "Message Subject $subject\n";
                        print "Message Body $body\n";
                        for (my $i = 0; $i <= $#attachments; $i++)
                        {
                            print "Message Attachment $attachments[$i]  -  $attachments_type[$i]  -  $attachments_relative[$i]\n";
                        }
                        print "Post to Blog Result: " . $postresult . "\n";
                        print "--------------------------\n";
                    }
                    
                }
                elsif ($print_output)
                {
                    print "Message To: $to\n";
                    print "Message From $from\n";
                    print "Message Subject $subject\n";
                    print "Message Body $body\n";
                    for (my $i = 0; $i <= $#attachments; $i++)
                    {
                        print "Message Attachment $attachments[$i]  -  $attachments_type[$i]  -  $attachments_relative[$i]\n";
                    }
                    print "Not Posted to Blog";
				    print "Result of Posting Allowed: " . $posting_allowed . "\n";
                    print "--------------------------\n";
                }
            
                if ($delete_messages)
                {
                        $pop->delete($msgnum);
                }
                     
        }

        if ($delete_temp_files)
        {       
            $parser->filer->purge;
        }  
}
$pop->quit;
